package com.laguerre.mytest;

import com.laguerre.kan.Behaviour;
import com.laguerre.kan.ImageEffects;
import com.laguerre.kan.PassShader;
import com.laguerre.kan.Shader;
import com.laguerre.kan.Utils;

public class GaussianBlurImageEffect extends Behaviour {
	private final Shader gaussianShader = new Shader();
	private final float[] texSteps = { 1f, 1f };

	@Override
	public void onAwake() {
		final PassShader passGaussian = this.gaussianShader.addPassShader(0);
		passGaussian.createProgram();
		passGaussian.attachVertexShader(ImageEffects.getBasicVertexShaderCode());
		passGaussian.attachFragmentShader(Utils.readTextFileFromRawResource(
				Utils.getContext(), R.raw.gaussian_blur_f_glsl));
		passGaussian.linkProgram();

		getSharedCamera().setAlternativePostEffectShader(this.gaussianShader);
	}

	@Override
	public void onBeforeRenderingImageEffectsPass(int passNum) {
		this.texSteps[0] = 1.0f / getSharedCamera().getWidth();
		this.texSteps[1] = 1.0f / getSharedCamera().getHeight();
		this.gaussianShader.setShaderVector("texSteps", this.texSteps);
	}

	@Override
	public void onDestroy() {
		gaussianShader.destroyResources();
	}
}
