package com.laguerre.mytest;

import com.laguerre.kan.Behaviour;
import com.laguerre.kan.ImageEffects;
import com.laguerre.kan.PassShader;
import com.laguerre.kan.Shader;
import com.laguerre.kan.Utils;

public class LaplaceEdgeImageEffect extends Behaviour {
	private final Shader laplaceShader = new Shader();
	private final float[] texSteps = { 1f, 1f };

	@Override
	public void onAwake() {
		final PassShader passLaplace = this.laplaceShader.addPassShader(0);
		passLaplace.createProgram();
		passLaplace.attachVertexShader(ImageEffects.getBasicVertexShaderCode());
		passLaplace.attachFragmentShader(Utils.readTextFileFromRawResource(
				Utils.getContext(), R.raw.laplace_edge_f_glsl));
		passLaplace.linkProgram();

		getSharedCamera().setAlternativePostEffectShader(this.laplaceShader);
	}

	@Override
	public void onBeforeRenderingImageEffectsPass(int passNum) {
		this.texSteps[0] = 1.0f / getSharedCamera().getWidth();
		this.texSteps[1] = 1.0f / getSharedCamera().getHeight();
		this.laplaceShader.setShaderVector("texSteps", this.texSteps);
	}

	@Override
	public void onDestroy() {
		laplaceShader.destroyResources();
	}
}
