package com.laguerre.mytest;

import com.laguerre.kan.AManualMesh;

public class SimpleQuad extends AManualMesh {
	private static final float[] quadVertices = {
		-1.0f,  1.0f, 0.0f, 1.0f,   // top left
		-1.0f, -1.0f, 0.0f, 1.0f,   // bottom left
		 1.0f, -1.0f, 0.0f, 1.0f,   // bottom right
		 1.0f,  1.0f, 0.0f, 1.0f    // top right
	};

    private static final float[] quadNormals = {
        0.0f, 0.0f, 1.0f,   // top left
        0.0f, 0.0f, 1.0f,   // bottom left
        0.0f, 0.0f, 1.0f,   // bottom right
        0.0f, 0.0f, 1.0f    // top right
    };

    private static final float[] quadTangents = {
        1.0f, 0.0f, 0.0f, 1f,   // top left
        1.0f, 0.0f, 0.0f, 1f,   // bottom left
        1.0f, 0.0f, 0.0f, 1f,   // bottom right
        1.0f, 0.0f, 0.0f, 1f    // top right
    };

	private static final float[] quadUVs = {
		0.0f, 1.0f, // top left
		0.0f, 0.0f, // bottom left
		1.0f, 0.0f, // bottom right
		1.0f, 1.0f  // top right
	};

	private static short[] drawList = {
		0, 1, 2, 0, 2, 3
	};

	@Override
	public void init() {
		setVertices(quadVertices);
		setNormals(quadNormals);
		setTangents(quadTangents);
		setUVs(quadUVs);
		setTriangles(drawList, 0);
		build();
	}
}
